#!/bin/bash

GITLAB_URL="$(cat credentials/gitlab_url)"
CERT_NAME="credentials/my.crt"
TOKEN="$(cat credentials/gitlab_admin_token)"
GITLAB_UID="$(cat credentials/gitlab_admin_uid)"
ISSUES_FOLDER=$1
CSV_PATH=$2
MILESTONE_NAME=$3
START_DATE=$4
DUE_DATE=$5

function print_help {
    echo Authenticates against a GitLab API and creates issues for many
    echo projects. Optionally, a milestone to be created can be specified
    echo
    echo Usage: $0 ISSUES_FOLDER PROJECTS_CSV_FILE [MILESTONE_NAME START_DATE DUE_DATE]
    echo
    echo The ISSUES_FOLDER should contain data like:
    echo
    echo "ISSUES_FOLDER/"
    echo " |"
    echo " |-- user1/"
    echo " |    |"
    echo " |    |-- issues/"
    echo " |         |"
    echo " |         |-- first_issue.md"
    echo " |         |-- second_issue.md"
    echo " |         |-- third_issue.md"
    echo " |"
    echo " |-- user2/"
    echo " |    |"
    echo 
    echo " (etc)"
    echo
    echo Typically, you want to use the \'gitlab_issues\' folder
    echo generated by 03_process_templates.sh. Note that the 
    echo -e "\e[1;33mfirst line\e[0m of each markdown file will be used as"
    echo title for the issue. There should be a blank line right afterwards.
    echo  
    echo The PROJECTS_CSV_FILE should contain data like:
    echo
    echo uid1,username1,Name1 LastName1,name1@email.com,project_id1,ssh_url1
    echo uid2,username2,Name2 LastName2,name2@email.com,project_id2,ssh_url2
    echo ...
    echo
    echo Typically, you want to use the output of 02_create_projects.sh
    echo
    echo "It is expected that the number of users (and projects) described"
    echo in PROJECTS_CSV_FILE matches the folder names inside ISSUES_FOLDER.
    echo
    echo Also, you can optionally create a milestone and every issue
    echo will be assigned to it. For example:
    echo
    echo $0 ... \"Sprint 3\" 2022-05-23 2022-06-01
}

if [[ "$1" = "--help" || "$1" = "-h" ]]; then
	print_help
	echo
    echo -e "\e[33mVersion: \e[0m1.1.0 (30/05/2022)"
	exit 0
fi

if [[ $GITLAB_URL == 'https://my.gitlab.instance' ]]; then
    echo -e "\e[1;31mERROR: \e[0mIt appears that default (dummy) credentials are being used. You should appropriately configure the contents of credentials/ folder to allow access to your GitLab instance."
    exit -1
fi

if [[ $# != 2 && $# != 5 ]]; then
    echo -e "\e[1;31mERROR: \e[0mIllegal number of parameters."
    echo
    print_help
    exit -1
fi

if [ -z "$(command -v jq)" ]; then
	echo jq is not installed, you can install it using sudo apt-get install jq
	exit -1
fi

echo Removing responses folder for any previous run...
rm -rf responses
echo Creating new folder...
mkdir responses

echo Sending out version check request...
curl --cacert $CERT_NAME --header "PRIVATE-TOKEN: $TOKEN" "$GITLAB_URL/api/v4/version" | jq . > responses/version.json
gversion=$(jq .version responses/version.json)
if [[ -z ${gversion} || "$gversion" == "null" ]]; then
	echo -e "\e[1;31mERROR: \e[0mWrong response. Halting execution. Maybe you want to verify the GITLAB_URL, GITLAB_UID, TOKEN or CERT_NAME inside the script"
	exit -1
else
	echo -e "\e[42m[OK]\e[0m Successfully received response from host."
	echo GitLab version is $gversion
fi

echo Reading CSV file with already existing user data...
while IFS=, read -r uid username name email project_id ssh_url
do
	# This will fire HTTP requests against the GitLab API in a for-loop
	# That is dangerous! Take into consideration the number of projects to
	# create and the rate limits configuration of your instance
	# https://docs.gitlab.com/ee/security/rate_limits.html
	echo ========================================
	username=`sed -e 's/^"//' -e 's/"$//' <<<"$username"` # https://tecadmin.net/bash-remove-double-quote-string/
	echo Creating issues for $username...
	if [[ -z $MILESTONE_NAME || -z $START_DATE || -z $DUE_DATE ]]; then
		echo You have not specified to create any milestone. Skipping...
	else
		echo You specified to assign all issues in every project to a newly created milestone $MILESTONE_NAME. Start date=$START_DATE, Due date=$DUE_DATE
		curl --cacert $CERT_NAME -X POST --header "PRIVATE-TOKEN: $TOKEN" \
			-F "title=$MILESTONE_NAME" \
			-F "start_date=$START_DATE" \
			-F "due_date=$DUE_DATE" \
			"$GITLAB_URL/api/v4/projects/$project_id/milestones" | jq . > responses/create_milestone_$username.json
		milestone_id=$(jq .id responses/create_milestone_$username.json)
		if [[ -z ${milestone_id} || "$milestone_id" == "null" ]]; then
			echo -e "\e[1;31mERROR: \e[0mWrong response. Halting execution. Maybe you want to verify create_milestone_$username.json under responses/ folder"
			echo -e "\e[1;33mWARNING: \e[0mSome issues might have been created and some others might have not. Maybe you want to check it and modify ISSUES_FOLDER and PROJECTS_CSV_FILE accordingly for the next run..."
			exit -1
		else
			echo -e "\e[42m[OK]\e[0m Successfully created milestone with id $milestone_id"
		fi
	fi
	
	user_issues_folder="$ISSUES_FOLDER/$username/issues"
	if [ ! -d "$user_issues_folder" ]; then
		echo -e "\e[1;31mERROR: \e[0mDirectory $user_issues_folder does not exist. What to do? Aborting..."
		exit -1
	fi
	
	i=1
	for issue in $user_issues_folder/*; do
		issue_title=$(head -n 1 $issue)
		issue_body=$(tail -n+2 $issue)
		echo "Creating issue named $issue_title for $username in project $project_id"
		curl --cacert $CERT_NAME -X POST --header "PRIVATE-TOKEN: $TOKEN" \
			-F "title=$issue_title" \
			--form-string "description=$issue_body" \
			-F "milestone_id=$milestone_id" \
			-F "assignee_ids=$uid" \
			"$GITLAB_URL/api/v4/projects/$project_id/issues" | jq . > "responses/create_issue_${username}_${i}.json"
		
		issue_id=$(jq .id "responses/create_issue_${username}_${i}.json")
		if [[ -z ${issue_id} || "$issue_id" == "null" ]]; then
			echo -e "\e[1;31mERROR: \e[0mWrong response. Halting execution. Maybe you want to verify create_issue_${username}_${i}.json under responses/ folder"
			echo -e "\e[1;33mWARNING: \e[0mSome issues might have been created and some others might have not. Maybe you want to check it and modify ISSUES_FOLDER and PROJECTS_CSV_FILE accordingly for the next run..."
			exit -1
		else
			echo -e "\e[32m[DONE]\e[0m Successfully created issue $issue_title for $username"
		fi
		i=$((i+1))
	done
done < $CSV_PATH
echo Removing responses folder after requests loop has exited successfully...
rm -rf responses
echo -e "\e[42m[OK]\e[0m All finished. Have a nice day!"
